import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { MerchantChargePackage, MerchantChargePackageParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商家充值套餐
 */
export async function pageMerchantChargePackage(params: MerchantChargePackageParam) {
  const res = await request.get<ApiResult<PageResult<MerchantChargePackage>>>(
    MODULES_API_URL + '/shop/merchant-charge-package/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商家充值套餐列表
 */
export async function listMerchantChargePackage(params?: MerchantChargePackageParam) {
  const res = await request.get<ApiResult<MerchantChargePackage[]>>(
    MODULES_API_URL + '/shop/merchant-charge-package',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商家充值套餐
 */
export async function addMerchantChargePackage(data: MerchantChargePackage) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-charge-package',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商家充值套餐
 */
export async function updateMerchantChargePackage(data: MerchantChargePackage) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-charge-package',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商家充值套餐
 */
export async function removeMerchantChargePackage(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-charge-package/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商家充值套餐
 */
export async function removeBatchMerchantChargePackage(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-charge-package/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商家充值套餐
 */
export async function getMerchantChargePackage(id: number) {
  const res = await request.get<ApiResult<MerchantChargePackage>>(
    MODULES_API_URL + '/shop/merchant-charge-package/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
